﻿unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls,
  WEBLib.ExtCtrls, WEBLib.JSON, System.Variants, jsdelphisystem;

type
  TForm1 = class(TWebForm)
    WebMemo1: TWebMemo;
    WebSplitter1: TWebSplitter;
    WebButton1: TWebButton;
    WebSplitter2: TWebSplitter;
    WebMemo2: TWebMemo;
    procedure WebButton1Click(Sender: TObject);
  private
    { Private declarations }
    procedure ParseMyJSON;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ParseMyJSON;
var
  a: TJSON;
  j: TJSObject;
  js,CdsObj,CurRecord: TJSONObject;
  DataArray,ValuesArray:TJSONArray;
  i,k,l: Integer;
begin
  WebMemo2.Lines.Clear;
  a := TJSON.Create;
  try
    js := a.Parse(WebMemo1.Lines.Text);
    j := js.JSObject;
    if j.hasOwnProperty('ERRORS') then
    begin
      WebMemo2.Lines.Add('Has "ERRORS" with value "'+
                         js.GetJSONValue('ERRORS')+'"'+
                         BoolToStr(IsString(js.GetValue('ERRORS'))));
    end;
    if j.hasOwnProperty('WARNINGS') then
    begin
      WebMemo2.Lines.Add('Has "WARNINGS" with value "'+
                         js.GetJSONValue('WARNINGS')+'"');
    end;
    if j.hasOwnProperty('MESSAGES') then
    begin
      WebMemo2.Lines.Add('Has "MESSAGES" with value "'+
                         js.GetJSONValue('MESSAGES')+'"');
    end;
    if j.hasOwnProperty('DATA') then
    begin
      DataArray:= TJSONArray(js.Values['DATA']);
      WebMemo2.Lines.Add('Has "DATA" with '+IntToStr(DataArray.Count));
      for i := 0 to DataArray.Count-1 do
      begin
        CdsObj:=TJSONObject(DataArray.Items[i]);
        if CdsObj.JSObject.hasOwnProperty('TableName') then
          WebMemo2.Lines.Add('Has "TableName" with value "'+CdsObj.GetJSONValue('TableName')+'"');
        if CdsObj.JSObject.hasOwnProperty('Values') then
        begin
          ValuesArray:=TJSONArray(CdsObj.Values['Values']);
          WebMemo2.Lines.Add('Has "Values" with '+IntToStr(ValuesArray.Count));
          for k := 0 to ValuesArray.Count-1 do
          begin
            WebMemo2.Lines.Add('Record '+IntToStr(k));
            CurRecord:=TJSONObject(ValuesArray.Items[k]);
            for l := 0 to length(TJsObject.keys(CurRecord.JSObject))-1 do
            begin
              WebMemo2.Lines.Add(TJSObject.keys(CurRecord.JSObject)[l]+':'+CurRecord.GetJSONValue(TJSObject.keys(CurRecord.JSObject)[l]) );
            end;
          end;
        end;
      end;
    end;
  finally
    a.Free; // is this necessary
  end;
end;


procedure TForm1.WebButton1Click(Sender: TObject);
begin
  ParseMyJSON;
end;

end.